import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class FastTbl extends Frame
{  public Complex[] TW1;
   public Complex[] TW2;
   public int    [] BTab;

   public double currentX, currentY; // ݂̕`ʒu
   public FastTbl()
   {  setSize(800,400);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private void Twinddle(int Max)
   {  TW1=new Complex[Max+1];
      double Arg = -6.28318530717959 / Max;
      for(int j = 0; j<=Max; j++) TW1[j] = Complex.expJ(Arg * j);
   }
   private void ITwinddle(int Max)
   {  TW2=new Complex[Max+1];
      double Arg = 6.28318530717959 / Max;
      for(int j = 0; j<=Max; j++) TW2[j] = Complex.expJ(Arg * j);
   }
   private void BitTable(int Max)
   {  
      BTab = new int[Max+1];
      int n_half = Max / 2; int ne=1; BTab[0] = 0;
      while (ne < Max)
      { for(int jp = 0; jp< ne; jp++) BTab[jp + ne] =BTab[jp] + n_half;
        n_half /= 2; ne *= 2;
      }
   }
   private Complex[] FFTandIFFT_tbl(Complex [] X, int Max, int flag)  //\ɍ쐬Ă@
   { Complex YY, yTemp;
     int n = Max; Complex[]Y = new Complex [n+1];
     for(int k = 0; k <= n; k++) Y[k] = X[k];
    
     int n_half = n / 2; int ne = 1;  // FFŤvZ
     while(ne < n)
     {  int n_half2 = n_half * 2;
        for(int jp = 0; jp< n; jp += n_half2)
        { int jx = 0;
          for(int j = jp; j< jp + n_half; j++)
          { int jnh = j + n_half;
            yTemp = Y[j]; Y[j] = yTemp.add(Y[jnh]);       //o^tCvZ
            Complex W = TW1[jx]; if(flag < 0) W = TW2[jx];
            Y[jnh] = (yTemp.sub(Y[jnh])).mult(W); 
            jx = jx + ne;
          }
        }
        n_half /= 2;   ne *= 2;
     }
     // rbgt̕ёւ
     for(int j = 0; j< n; j++)
     {  int jx = BTab[j];
        if(j < jx)
        { yTemp = Y[j]; Y[j] = Y[jx]; Y[jx] = yTemp;
        }
     }
     Y[Max] = Y[0];
     return Y;
   }
  public Complex[] FFT_tbl(Complex [] X, int Max)
  {  return FFTandIFFT_tbl(X,Max,1);
  }
  public Complex[] IFFT_tbl(Complex [] X, int Max)
  {   Complex[] Y = FFTandIFFT_tbl(X, Max, -1);
      for(int k = 0; k < Max; k++)  Y[k] = Y[k].div((double) Max);
      Y[Max] = Y[0];
      return Y;
  }

   public int Xpos(double X)
   {  return (int)(X*20)+100;}
   public int Ypos(double Y)
   {  return 200- (int)(Y*40);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }

   public void paint(Graphics g)
   { 
     int Max = 64;int i,k; boolean Flag = false;
     Complex [] X = new Complex[Max + 1];
     int N1 = Max / 3; int N2 = N1 * 2;
     double DN1 = (double)N1/3;     
     for(i = 0 ; i<= Max; i++)
     {  if(i>=N1 && i<N2) X[i]= new Complex(1,0); 
        else            X[i]= new Complex(0,0); 
     }
     Twinddle(Max); ITwinddle(Max); BitTable(Max);
     Complex [] Y1 = FFT_tbl(X, Max);
     Complex [] Y2 = IFFT_tbl(Y1, Max);

     setTitle("]qƃrbgt̕\ɍ쐬ĂFFT");
     g.drawString("`gFFTIFFT",100,100);
     g.drawString("FFT",310,200);
     g.drawString("IFFT",310,280);
     
     g.setColor(new Color(0,0,255));
     
     Flag = false;
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k/DN1, X[k].R, Flag);
     Flag = false;
     g.setColor(new Color(255,0,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k/DN1+15, Y1[k].R/10-1, Flag);
     
     Flag = false;
     g.setColor(new Color(0,255,0));
     for(k = 0; k <=Max; k++)  Flag = Draw(g,(double)k/DN1, Y2[k].R-2, Flag);
    
   } 
   public static void main(String[] args)
   {  Frame w = new FastTbl();
      w.setVisible(true);
   }
}
